/*
 * Compostion_Statistics.cpp
 *
 *  Created on: May 11, 2011
 *      Author: fritz
 */

#include "Composition_Statistics.h"


Composition_Statitstics::Composition_Statitstics(int max_length,char const * const fileName){
	this->max_length=max_length;
	this->fileName=string(fileName);
	this->fileName+="_comp";
	this->init();
}


void Composition_Statitstics::init(){
	vector<int > base;
	base.resize(5,0);

	for(int i=0;i<this->max_length;i++){
		this->bases.resize((size_t)this->max_length,base);
	}
}


void Composition_Statitstics::add(char const *  seq){
	for(int i=0;i<this->max_length && seq[i] !='\0';i++){
		switch (seq[i]){
			case 'A':
				this->bases[i][0]++;
				break;
			case 'C':
				this->bases[i][1]++;
				break;
			case 'G':
				this->bases[i][2]++;
				break;
			case 'T':
				this->bases[i][3]++;
				break;
			default:
				this->bases[i][4]++;
		}
	}
}

void Composition_Statitstics::print(){
	ofstream data;
	data.open(this->fileName .c_str(), std::ios::out);
	data.exceptions(ofstream::failbit | ofstream::badbit);
	data<<"#A\t#C\t#G\t#T\t#N\n";
	for(size_t i = 0;i<bases.size();i++){
		data<<bases[i][0]<<"\t"<<bases[i][1]<<"\t"<<bases[i][2]<<"\t"<<bases[i][3]<<'\n';
	}

	bases.clear();
	data.close();

	this->produce_plot();
}

void Composition_Statitstics::produce_plot(){

	ofstream script;
	script.open("script.R", std::ios::out);
	script<<"source(\"/software/ngm/bin-linux/scripts/summaries.r\")\n";
	script<<"png(\"";
	script<<this->fileName;
	script<<".png\")\n";
	script<<"composition_plot(\"";
	script<<this->fileName;
	script<<"\")\n";
	script<<"dev.off()\n";

	script.close();
	system("R CMD BATCH script.R ");
}


