/*
 * NgmRefWriter.h
 *
 *  Created on: May 4, 2011
 *      Author: philipp_
 */

#ifndef NGMREFWRITER_H_
#define NGMREFWRITER_H_

#include "NgmWriter.h"

class NgmRefWriter: public NgmWriter {

private:
	static int const sig = 0x524D474E;
	static int const entryLength = 32;

	ofstream dataCompl;

protected:
	FilePosition writeReference(ofstream & out, char * sequence, int const length,
			int const padding, bool reverse);

public:
	NgmRefWriter(char const * const fileName);
	virtual ~NgmRefWriter();

	FilePosition writeReference(char * sequence, int const length,
			int const padding);
	void writeIndexEntryRef(FilePosition outputOffset, int outputLength,
			FilePosition nameOffset, int nameLength, bool isValid,
			bool isComplValid);

	void writeRefHeader(int const refCount, int const flags, int const padding);
};

#endif /* NGMREFWRITER_H_ */
