/*
 * NgmWriter.cpp
 *
 *  Created on: May 4, 2011
 *      Author: philipp_
 */

#include "NgmWriter.h"

int const NgmWriter::version;
int const NgmWriter::headerLength;

NgmWriter::NgmWriter(int const sig, int const entryLength,
		char const * const fileName) :
	sig(sig), entryLength(entryLength), sequenceId(0) {

	data.open((std::string(fileName) + ".bs").c_str(), std::ios::out);
	idx.open((std::string(fileName) + ".idx").c_str(), std::ios::binary);

	data.exceptions(ofstream::failbit | ofstream::badbit);
	idx.exceptions(ofstream::failbit | ofstream::badbit);
}

void NgmWriter::toUpperCase(char * sequence, int sequenceLength) {
	int i = 0;
	while (sequence[i] != '\0') {
		sequence[i] = std::toupper(sequence[i]);
		i += 1;
	}
}

NgmWriter::~NgmWriter() {
	data.close();
	idx.close();
}

void NgmWriter::WriteHeader(unsigned int seqCount, unsigned int seqFieldWith,
		unsigned int flags, unsigned int checkSum) {
	//if (debug) {
	//	idx << sig << " " << headerLength << " " << seqCount << " "
	//			<< seqFieldWith << std::endl;
	//} else {
	idx.write((char *) &sig, 4);
	idx.write((char *) &version, 4);
	idx.write((char *) &headerLength, 4);
	idx.write((char *) &entryLength, 4);
	idx.write((char *) &seqCount, 4);
	idx.write((char *) &seqFieldWith, 4);
	idx.write((char *) &flags, 4);
	idx.write((char *) &checkSum, 4);
	//}
}
