/*
 * Parser.h
 *
 *  Created on: Feb 16, 2011
 *      Author: philipp_
 */

#ifndef PARSER_H_
#define PARSER_H_

#include <fstream>
#include <stdio.h>
#include <string>

#include "datatypes.h"

using std::string;
using std::ifstream;


class Parser {

protected:
	SEQFILE * ffp;

public:

	virtual char const * getFormatName() = 0;

	virtual void open(char *seqfile);
	virtual void close();

	virtual void init() {}

	virtual int getMaxReadLength(int & readCount, FilePosition & fileSize) = 0;
	//virtual int read(string & sequence, string & name) = 0;
	virtual bool read(string & name, Entry * entry) = 0;

};

#endif /* PARSER_H_ */
