#ifndef ___BAMWRITER_H___
#define ___BAMWRITER_H___

#include "GenericReadWriter.h"

class BAMWriter: public GenericReadWriter {
public:
	BAMWriter(char const * const filename) :
		GenericReadWriter(filename), file(filename) {
		if (Config.Exists("paired")){

			paired_end = (Config.GetInt("paired", 0, 1) == 1);
			if (Config.Exists("pair_min_distance")&&Config.Exists("pair_max_distance")){
				min_dist= Config.GetInt("pair_min_distance");
				max_dist=Config.GetInt("pair_max_distance");
			}else{
				Log.Warning("No paired end distance is set.");
				min_dist=0;
				max_dist=999999999;
			}
		}
		identity=0;
		if (Config.Exists("identity_tresh")){
			identity=Config.GetFloat("identity_tresh",0,100);
			identity=identity/100.0f;
		}

	}

protected:
	virtual void DoWriteProlog(FILE * fp);
	virtual void DoWriteRead(FILE * fp, MappedRead const * const read);
	virtual void DoWriteEpilog(FILE * fp);

private:
	char const * const file;
	bool paired_end;
	bool IsProperPaired(MappedRead const * const read);
	int min_dist;
	int max_dist;
	float identity;
};

#endif //___BAMWRITER_H___
