#ifndef __CSCACHE_H__
#define __CSCACHE_H__

#include <string>
#include <stdio.h>

#include "IRefProvider.h"
#include "Types.h"
#include "NGMThreads.h"

struct CacheIndex;
struct PageIndex;

class CSCache
{
public:
	// Creates a new, empty cache file
	static CSCache * CreateCache(std::string const filename, uint const pages);
	// Loads a cache file
	static CSCache * LoadCache(std::string const filename);

	// Gets number of pages in file
	int  GetPageCount() const;
	bool ContainsData(int const page) const;

	~CSCache();
private:
	void AddPage(int const page, char const * pBuffer, ulong const length);
	void LoadPage(int const page, char const * & pBuffer, ulong & length) const;

	void CommitHeader();

	CSCache(std::string const filename);

	std::string const m_Filename;
	FILE * m_FP;
	CacheIndex * m_Index;
	PageIndex * m_PageIndex;
	NGMMutex m_Mutex;

	friend class PrefixTable;
};


#endif
