#ifndef __GENERICREADWRITER_H__
#define __GENERICREADWRITER_H__

#include <stdio.h>
#include "ILog.h"
#include "Config.h"

struct MappedRead;

class GenericReadWriter
{
public:
	GenericReadWriter(char const * const filename)
	{
		if ( !(m_Output = fopen(filename, (Config.GetInt("append") != 1) ? "wb" : "ab")) )
		{
			Log.Error("Unable to open output file %s", filename);
		}
	}
	virtual ~GenericReadWriter()
	{
		if (m_Output)
			fclose(m_Output);
	}
protected:
	FILE * m_Output;
	virtual void DoWriteProlog(FILE * fp) = 0;
	virtual void DoWriteRead(FILE * fp, MappedRead const * const read) = 0;
	virtual void DoWriteEpilog(FILE * fp) = 0;
public:
	void WriteProlog()
	{
		if (m_Output)
			DoWriteProlog(m_Output);
	}
	void WriteRead(MappedRead const * const read)
	{
		if (m_Output)
		{
			DoWriteRead(m_Output, read);
			fflush(m_Output);
		}
	}
	void WriteEpilog()
	{
		if (m_Output)
			DoWriteEpilog(m_Output);
	}
};

#endif
