#ifndef __LOCATIONSCORE_H__
#define __LOCATIONSCORE_H__

#include "SequenceLocation.h"
#include "PlatformSpecifics.h"

struct MappedRead;

union UScore
{
	int i;
	float f;
};

struct LocationScore
{
	SequenceLocation Location;
	UScore Score;
	MappedRead * Read;
#ifdef INSTANCE_COUNTING
	static volatile int sInstanceCount;
#endif

	LocationScore() :
		Location(), Score(), Read(0)
	{
#ifdef INSTANCE_COUNTING
		AtomicInc(&sInstanceCount);
#endif
	}

	~LocationScore()
	{
#ifdef INSTANCE_COUNTING
		AtomicDec(&sInstanceCount);
#endif
	}

	LocationScore(SequenceLocation location, int score, MappedRead * read)
		: Location(location), Read( read )
	{
		Score.i = score;
#ifdef INSTANCE_COUNTING
		AtomicInc(&sInstanceCount);
#endif
	}

	LocationScore(LocationScore const & score)
	{
		Location = score.Location;
		Score = score.Score;
		Read = score.Read;
#ifdef INSTANCE_COUNTING
		AtomicInc(&sInstanceCount);
#endif
	}
};

#endif
