#ifndef __PARTITION_H__
#define __PARTITION_H__

#include <vector>
#include <list>

#include "ILog.h"
#include "SequenceProvider.h"

class SeqSector
{
private:
	int m_SeqId;
	int m_Start;
	int m_Length;

public:
	SeqSector(int seqId, int start, int length) :
		m_SeqId( seqId ),
		m_Start( start ),
		m_Length( length )
	{
		// Check Sequence Length: SeqProv.getLength(seqId) >= start+length
		if (SequenceProvider.GetRefLen(m_SeqId) < (m_Start + m_Length))
		{
			Log.Error("Invalid Sequence sector (SeqId = %i, Start = %i, Len = %i)", m_SeqId, m_Start, m_Length);
		}
	}

	char const * Sequence()
	{
		return SequenceProvider.GetRefSequence(m_SeqId) + m_Start;
	}

	int Length()
	{
		return m_Length;
	}

	int SeqId()
	{
		return m_SeqId;
	}

	int Start()
	{
		return m_Start;
	}
};

typedef std::vector<SeqSector> Partition;
typedef std::vector<Partition> PartitionList;

#endif
