#ifndef __REFENTRY_H__
#define __REFENTRY_H__

#include "SequenceLocation.h"
#include "Types.h"

struct RefEntry
{
	//static const int cIncrements[] = { 10, 20, 50, 100 };
	static int MaxRefsPerEntry;

	RefEntry(int locs = MaxRefsPerEntry)
	{
		ref = new SequenceLocation[locs];
		refCount = 0;
		refTotal = 0;
		nextEntry = 0;
	}
	~RefEntry()
	{
		if (nextEntry != 0)
			delete nextEntry;

		delete[] ref;
	}
	int refCount;
	int refTotal;
	SequenceLocation * ref;
	RefEntry* nextEntry;
private:
	//---section Flattening
	RefEntry(void const * pEntries, int count);
	friend class PrefixTable;
	//---section Flattening

};

struct PrefixRefRelay
{
	ulong Prefix;
	RefEntry* Entry;
	PrefixRefRelay* Next;

	PrefixRefRelay() : Prefix(0), Entry(0), Next(0)
	{
	}
	~PrefixRefRelay()
	{
	}
};

#endif
